Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class S_Document

    java.lang.Object

      |

      +--oracle.ifs.server.S_LibraryObject

            |

            +--oracle.ifs.server.S_TieLibraryObject

                  |

                  +--oracle.ifs.server.S_PublicObject

                        |

                        +--oracle.ifs.server.S_TiePublicObject

                              |

                              +--oracle.ifs.server.S_Document

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, PublicObjectInterface, Traceable

Direct Known Subclasses:
  S_TieDocument

public class S_Document
extends S_TiePublicObject

The S_Document class. This class handles getting and setting of content.

See Also:
  `S_LibraryService`, `S_LibrarySession`

Method Summary
`S_ContentObject` | `cloneContentObject(S_LibraryObjectDefinition def)` copies the content object then updates this document to reference the new copy.
`protected void` | `deriveDefinition(S_LibraryObjectDefinition def)` Add to the S_LibraryObjectDefinition for this class.
`protected void` | `extendedPreFree(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed before freeing an object.
`protected void` | `extendedPreInsert(OperationState opState, S_LibraryObjectDefinition def)` Update any system attributes appropriate for creating this object
`protected void` | `extendedPreUpdate(OperationState opState, S_LibraryObjectDefinition def)` Update any system attributes appropriate for updating this object
`java.io.Reader` | `getContentReader()` Gets the document content as a Reader
`long` | `getContentSize()` Gets the size of this document's content.
`java.io.InputStream` | `getContentStream()` Gets the document content as an InputStream.
`boolean` | `isVersionable()` returns true if this object can be in a Family

Methods inherited from class oracle.ifs.server.S_PublicObject
`addRelationship, getCategories, getLeftwardRelationshipObjects, getLeftwardRelationshipObjects, getLeftwardRelationships, getLeftwardRelationships, getReferencingFolders, getRightwardRelationshipObjects, getRightwardRelationshipObjects, getRightwardRelationships, getRightwardRelationships, getVersionDescriptions, hasNameAttribute, isLocked, removeRelationship`

Methods inherited from class oracle.ifs.server.S_LibraryObject
`equals, free, getAttribute, getAttributeByUpperCaseName, getClassId, getClassObject, getId, getSession, handleEvent, isTraced, postEvent, postEvent, renderAsReader, renderAsStream, setAttribute, setAttribute, toString, trace, update`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getId`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Method Detail

### deriveDefinition

    protected void deriveDefinition(S_LibraryObjectDefinition def)
                             throws IfsException

  Add to the S_LibraryObjectDefinition for this class. This this called by getDefinition() on S_LibraryObject. This must call super.deriveDefinition() before applying any class-specific changes to the S_LibraryObjectDefinition object.
  Overrides:
    `deriveDefinition` in class `S_PublicObject`
  Parameters:
    `def` - the S_LibraryObjectDefinition that contains the definition of the target object.
  Throws:
    `IfsException` - if operation fails.

### extendedPreInsert

    protected void extendedPreInsert(OperationState opState,
                                     S_LibraryObjectDefinition def)
                              throws IfsException

  Update any system attributes appropriate for creating this object
  Overrides:
    `extendedPreInsert` in class `S_PublicObject`
  Parameters:
    `opState` - current operation state
    `def` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.

### extendedPreUpdate

    protected void extendedPreUpdate(OperationState opState,
                                     S_LibraryObjectDefinition def)
                              throws IfsException

  Update any system attributes appropriate for updating this object
  Overrides:
    `extendedPreUpdate` in class `S_PublicObject`
  Parameters:
    `the` - operation state
    `def` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.

### extendedPreFree

    protected void extendedPreFree(OperationState opState,
                                   S_LibraryObjectDefinition def)
                            throws IfsException

  operations to be performed before freeing an object.
  Overrides:
    `extendedPreFree` in class `S_PublicObject`
  Parameters:
    `opState` - the OperationState
    `def` - the Definition containing options for this operation
  Throws:
    `IfsException` - if operation fails.

### cloneContentObject

    public S_ContentObject cloneContentObject(S_LibraryObjectDefinition def)
                                       throws IfsException

  copies the content object then updates this document to reference the new copy.
  Parameters:
    `def` - the Definition containing options for the new ContentObject
  Returns:
    the new ContentObject
  Throws:
    `IfsException` - if operation fails.

### isVersionable

    public boolean isVersionable()
                          throws IfsException

  returns true if this object can be in a Family
  Overrides:
    `isVersionable` in class `S_PublicObject`
  Returns:
    true if this object can be in a Family
  Throws:
    `IfsException` - if the operation fails

### getContentStream

    public java.io.InputStream getContentStream()
                                         throws IfsException

  Gets the document content as an InputStream.
  Returns:
    an InputStream of the content or null if this document does not have content
  Throws:
    `IfsException` - if operation fails.

### getContentReader

    public java.io.Reader getContentReader()
                                    throws IfsException

  Gets the document content as a Reader
  Returns:
    a Reader of the content or null if this document does not have content
  Throws:
    `IfsException` - if operation fails.

### getContentSize

    public long getContentSize()
                        throws IfsException

  Gets the size of this document's content. It returns 0 (zero) if the content is zero length or if this document has a null ContentObject
  Returns:
    the size of the underlying content.
  Throws:
    `IfsException` - if operation fails.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD